﻿Type=Activity
Version=3
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'Se definen las variables requeridas para la geolocalización
	Dim vGPS As GPS   'Getionará el objeto GPS del dispositivo
	Dim LocalizacionActual As Location  'Tomará las coordenadas actuales
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Dim camera1 As CameraExClass
	Dim PanelFoto1, pnlBarra,pnlCentro As Panel
	Dim imgPanoramica As ImageView 
	Dim imgSiguiente, imgMenu,imgCamara,imgFoto,img_imagen As ImageView 

	Dim lblLongitud As Label
    Dim lblLatitud As Label
	Dim lblAccuracy As Label 

	Dim imgAyuda As ImageView
	Dim fotoTomada As Boolean : fotoTomada= False
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("p4_foto1")

	'Activar GPS
	If FirstTime Then
        vGPS.Initialize("GPS")
		 ToastMessageShow("Iniciando GPS...", False)
    End If

	'Se inicia el objeto que almacenará el punto actual
	LocalizacionActual.Initialize
	lblLongitud.Text = "Lat="
	lblLatitud.Text  = "Long="
	Pantalla_Formatear
	Pantalla_Pintar
	Msgbox ("Ubique una buena posición para la panorámica del cultivo con algún punto de referencia visible que pueda volver a ubicar","Foto panorámica")

End Sub

Sub Activity_Resume
	If vGPS.GPSEnabled = False Then
        ToastMessageShow("Please enable the GPS device.", True)
        StartActivity(vGPS.LocationSettingsIntent) 'Will open the relevant settings screen.
    Else
        'ToastMessageShow("Activity_Resume GPS habilitado", True)
        vGPS.Start(500, 0) 'Listen to GPS with no filters.
    End If 
	
	imgFoto.Visible  = False  'Inactiva la modalidad de mostrar la foto
	'Inicializa la camara solo lente trasero. Eventos empezarán con la palabra Camera1
	camera1.Initialize(PanelFoto1, False, Me, "Camera1") 

	'Pantalla_Pintar 
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	camera1.Release  'Libera la camara
    'vGPS.Stop
End Sub

Sub GPS_LocationChanged (Location1 As Location)
 	'captura la coordenada actual todo el tiempo.
  
    LocalizacionActual.Latitude = Location1.Latitude
  	LocalizacionActual.Longitude = Location1.Longitude
  	LocalizacionActual.Accuracy = Location1.Accuracy
	LocalizacionActual.Altitude = Location1.Altitude  'Altitud

	'Si está activa la camara, visualizar las coordenadas del GPS
	If imgFoto.Visible = True Then
		lblLatitud.Text =  "Lat = " & Datos.CoordenadasGrados(Location1.ConvertToSeconds(Location1.Latitude),True)   
	    lblLongitud.Text = "Lon = " & Datos.CoordenadasGrados(Location1.ConvertToSeconds(Location1.Longitude) ,True)  
		lblAccuracy.Text = Round(Location1.Accuracy) & " mts (" & Location1.AccuracyValid & ")"
	End If
	
End Sub

Sub Camera1_Ready (Success As Boolean)
	If Success Then
		'camera1.SetJpegQuality(100)
		Proceso.MaximaResolucion (camera1)
		camera1.StartPreview
		imgFoto.Visible = True
	Else
		ToastMessageShow("Cannot open camera.", True)
	End If
End Sub

Sub Camera1_PictureTaken (Data() As Byte)
	If Data =  Null Then  ''WHY IT ARRIVES NULLLL?????
				  Msgbox("Vuelva a intentarlo","Aviso")
		  Return
	End If



	'Eliminar si hay foto previa en directorio
	Try
		File.Delete(Base.g_DirInterno & "/Erradica",Base.g_Codigo & "_1.jpg")
	Catch
		Log("Foto no eliminada o no existe")
	End Try	


	Try
		'Guardar las coordenadas de la foto tomada
		Base.g_Foto1_Lat = LocalizacionActual.Latitude
		Base.g_Foto1_Long = LocalizacionActual.Longitude
		Base.g_Foto1_Accuracy =  LocalizacionActual.Accuracy

		'Proceso.AlmacenarVariableFotoCoordenada(1)

		camera1.SavePictureToFile(Data,Base.g_DirInterno & "/Erradica",Base.g_Codigo & "_1.jpg")
		
		Msgbox("La foto ha sido tomada y almacenada con éxito","Aviso")
		imgFoto.Enabled =  True
		fotoTomada= True
		'Pantalla_Pintar
	Catch
		'ToastMessageShow("Error tomando la foto, intentelo de nuevo...", True)
		Log("Error tomando la foto, intentelo de nuevo...")
	End Try

	'camera1.StartPreview
	'Pantalla_Pintar 
End Sub

Sub VisualizarFoto
	Dim primerintento As Boolean : primerintento = True
	If File.Exists(Base.g_DirInterno & "/Erradica", Base.g_Codigo & "_1.jpg") = True Then
			Try
				imgPanoramica.Bitmap = LoadBitmapSample(Base.g_DirInterno & "/Erradica/", Base.g_Codigo & "_1.jpg",imgPanoramica.Width ,imgPanoramica.Height )   
			Catch
				Log("Error cargado foto 1")
				primerintento = False
				'jco
				Msgbox("Error visualizando la foto","1")
					Try
						File.Delete(Base.g_DirInterno & "/Erradica",Base.g_Codigo & "_1.jpg")
					Catch
						Log("Foto no eliminada o no existe")
					End Try	
	
			End Try


			lblLatitud.Text =  "Foto: Lat = " &  Datos.CoordenadasGrados(LocalizacionActual.ConvertToSeconds(Base.g_Foto1_Lat),False)  
		    lblLongitud.Text = "Foto: Lon = " & Datos.CoordenadasGrados(LocalizacionActual.ConvertToSeconds(Base.g_Foto1_Long),False)   

			PanelFoto1.Visible = False    'Inactiva el panel donde se activa la camara
			imgPanoramica.Visible = True  'Activa el panel que muestra la foto pre-almacenada
			imgFoto.Visible  = False      'desactiva el boton de imagen de la foto, dado que ya se está en esta opción

			fotoTomada= True
	Else
			fotoTomada= False
	End If

End Sub

Sub imgCamara_Click
	imgFoto.Visible  = True  'Activar boton de tomar la foto
	PanelFoto1.Visible = True  'Activar el panel de la camara
	imgPanoramica.Visible = False 'DesActivar visualizar imagen pre-guardada
	camera1.StartPreview 
End Sub

Sub imgFoto_Click
	imgFoto.Visible  = False 'Desactivar boton de tomar la foto, ya fue tomada
	camera1.TakePicture	     'Tomar la foto a través del sistema operativo
End Sub

Sub img_imagen_Click
		Pantalla_Pintar 
End Sub

Sub Pantalla_Pintar 
	VisualizarFoto
End Sub

Sub Pantalla_Formatear
	'Centrar el panel del menú en el dispositivo
	pnlBarra.Left = (100%x - pnlBarra.Width)/2
	pnlBarra.Top = 5%y
	pnlCentro.Left = pnlBarra.Left 
	pnlCentro.Top = pnlBarra.Top +  pnlBarra.Height + 10
End Sub

Sub imgSiguiente_Click
 If fotoTomada = False Then
	Msgbox ("Se requiere tomar la foto para avanzar.","Falta completar datos")
 Else
	 
	Base.g_Paso = 3
	Proceso.NavegarPantallaPaso
	Activity.Finish

End If
End Sub
Sub imgMenu_Click
  If  Msgbox2 ("Saldrá del reporte del cultivo, ¿está seguro que desea continuar?" , "Advertencia","Pausar/Terminar","Cancelar","",Null) = DialogResponse.POSITIVE Then
	Activity.Finish 
  End If
  
End Sub
Sub Activity_KeyPress (KeyCode As Int) As Boolean 
   If KeyCode = KeyCodes.KEYCODE_BACK Then
			 If  Msgbox2 ("Saldrá del reporte del cultivo, ¿está seguro que desea continuar?" , "Advertencia","Pausar/Terminar","Cancelar","",Null) = DialogResponse.POSITIVE Then
				Activity.Finish 
			 End If
            Return True  'No continua con el evento propio de Android. Solo ejecuta nuestro código
    Else
		   Return False  'Continua con el comportamiento normal del botón
	End If
End Sub

Sub imgAyuda_Click
	Dim Intent1 As Intent
	Intent1.Initialize(Intent1.ACTION_VIEW, Base.g_ManualAyuda)
	
	Intent1.SetComponent("android/com.android.internal.app.ResolverActivity")
    Intent1.SetType("application/pdf")
    StartActivity(Intent1)
End Sub

