﻿Type=Activity
Version=3
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
    Dim vGPS As GPS
	Dim LocalizacionActual As Location 

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim camera1 As CameraExClass
	
	Dim PanelFoto1, pnlBarra,pnlCentro As Panel
	Dim imgPanoramica As ImageView 
	Dim imgSiguiente, imgMenu,imgCamara,imgFoto,img_imagen As ImageView 
	Dim lblLongitud As Label
    Dim lblLatitud As Label
	Dim lblAccuracy As Label 

	Dim imgAyuda As ImageView
	Dim fotoTomada As Boolean : fotoTomada= False
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("p5_foto2")

	'Activar GPS
	If FirstTime Then
        vGPS.Initialize("GPS")
		 ToastMessageShow("Iniciando GPS...", False)
    End If


	'Se inicia el objeto que almacenará el punto actual
	LocalizacionActual.Initialize
	lblLongitud.Text = "Lat="
	lblLatitud.Text  = "Long="

	Pantalla_Formatear
	Pantalla_Pintar

	Msgbox ("Tome una foto de cerca a una planta del cultivo","Foto planta")

End Sub

Sub Activity_Resume
	If vGPS.GPSEnabled = False Then
        ToastMessageShow("Please enable the GPS device.", True)
        StartActivity(vGPS.LocationSettingsIntent) 'Will open the relevant settings screen.
    Else
        'ToastMessageShow("Activity_Resume GPS habilitado", True)
        vGPS.Start(500, 0) 'Listen to GPS with no filters.
    End If 

	
	imgFoto.Visible  = False  'btnTakePicture.Enabled = False
	
	camera1.Initialize(PanelFoto1, False, Me, "Camera1") 
	'Pantalla_Pintar 
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	camera1.Release
    'vGPS.Stop

End Sub

Sub GPS_LocationChanged (Location1 As Location)
 	'captura la coordenada actual todo el tiempo.
    LocalizacionActual.Latitude = Location1.Latitude
  	LocalizacionActual.Longitude = Location1.Longitude
  	LocalizacionActual.Accuracy = Location1.Accuracy
	LocalizacionActual.Altitude = Location1.Altitude  'Altitud

	If imgFoto.Visible = True Then
	lblLatitud.Text =  "Lat = " & Datos.CoordenadasGrados(Location1.ConvertToSeconds(Location1.Latitude) ,True)  
	lblLongitud.Text = "Lon = " & Datos.CoordenadasGrados(Location1.ConvertToSeconds(Location1.Longitude) ,True)  
	lblAccuracy.Text = Round(Location1.Accuracy) & " mts (" & Location1.AccuracyValid & ")"
	End If
	
End Sub

Sub Camera1_Ready (Success As Boolean)
	If Success Then
		'camera1.SetJpegQuality(100)
		Proceso.MaximaResolucion (camera1)

		camera1.StartPreview
		imgFoto.Visible = True
	Else
		ToastMessageShow("Cannot open camera.", True)
	End If
End Sub

Sub Camera1_PictureTaken (Data() As Byte)
	If Data =  Null Then  ''WHY IT ARRIVES NULLLL?????
				  Msgbox("Vuelva a intentarlo","Aviso")
		  Return
	End If


	'Eliminar si hay foto previa en directorio
	Try
		File.Delete(Base.g_DirInterno & "/Erradica",Base.g_Codigo & "_2.jpg")
	Catch
		Log("Foto no eliminada o no existe")
	End Try	

	Try

		Base.g_Foto2_Lat = LocalizacionActual.Latitude
		Base.g_Foto2_Long = LocalizacionActual.Longitude
		Base.g_Foto2_Accuracy =  LocalizacionActual.Accuracy	
		
		'Proceso.AlmacenarVariableFotoCoordenada(2)
		
		camera1.SavePictureToFile(Data,Base.g_DirInterno & "/Erradica/",Base.g_Codigo & "_2.jpg")

		Msgbox("La foto ha sido tomada y almacenada con éxito","Aviso")
		imgFoto.Enabled =  True
		fotoTomada= True
		'Pantalla_Pintar

	Catch
		Log("Error tomando la foto, intentelo de nuevo...")
	End Try
	
 
	'camera1.StartPreview
	'Pantalla_Pintar 
End Sub

Sub VisualizarFoto
	Dim primerintento As Boolean : primerintento = True
	If File.Exists(Base.g_DirInterno & "/Erradica", Base.g_Codigo & "_2.jpg") = True Then
			Try
				imgPanoramica.Bitmap = LoadBitmapSample(Base.g_DirInterno & "/Erradica/", Base.g_Codigo & "_2.jpg",imgPanoramica.Width ,imgPanoramica.Height )   
			Catch
				Log("Error cargado foto 2")
				primerintento = False
			End Try

			If primerintento  Then
				'Segundo intento		
				Try
					imgPanoramica.Bitmap = LoadBitmapSample(Base.g_DirInterno & "/Erradica/", Base.g_Codigo & "_2.jpg",imgPanoramica.Width ,imgPanoramica.Height )   
				Catch
					Log("Error cargado foto 2")
				End Try
			End If

		    'imagePhoto.Gravity = Gravity.FILL
				'En modo visualización, se muestra las coordenadas de la foto y no la del GPS
			lblLatitud.Text =  "Foto: Lat = " &  Datos.CoordenadasGrados(LocalizacionActual.ConvertToSeconds(Base.g_Foto2_Lat),False)  
		    lblLongitud.Text = "Foto: Lon = " & Datos.CoordenadasGrados(LocalizacionActual.ConvertToSeconds(Base.g_Foto2_Long),False)   

			PanelFoto1.Visible = False    'Inactiva el panel donde se activa la camara
			imgPanoramica.Visible = True  'Activa el panel que muestra la foto pre-almacenada
			imgFoto.Visible  = False      'desactiva el boton de imagen de la foto, dado que ya se está en esta opción

			fotoTomada= True
	Else
			fotoTomada= False
	End If
End Sub

Sub imgFoto_Click
	imgFoto.Visible  = False 'btnTakePicture.Enabled = False
	camera1.TakePicture	
End Sub
Sub imgCamara_Click
	imgFoto.Visible  = True 'btnTakePicture.Enabled = True
	PanelFoto1.Visible = True
	imgPanoramica.Visible = False	
	camera1.StartPreview 

End Sub
Sub img_imagen_Click
		Pantalla_Pintar 
End Sub

Sub Pantalla_Pintar 
	VisualizarFoto
End Sub

Sub Pantalla_Formatear
	'Centrar el panel del menú en el dispositivo
	pnlBarra.Left = (100%x - pnlBarra.Width)/2
	pnlBarra.Top = 5%y
	pnlCentro.Left = pnlBarra.Left 
	pnlCentro.Top = pnlBarra.Top +  pnlBarra.Height + 10
End Sub

Sub imgSiguiente_Click
 If fotoTomada = False Then
	Msgbox ("Se requiere tomar la foto para avanzar.","Falta completar datos")
 Else
 
	Base.g_Paso = 4
	Proceso.NavegarPantallaPaso
    Activity.Finish
End If
End Sub
Sub imgMenu_Click
  If  Msgbox2 ("Saldrá del reporte del cultivo, ¿está seguro que desea continuar?" , "Advertencia","Pausar/Terminar","Cancelar","",Null) = DialogResponse.POSITIVE Then
	Activity.Finish 
  End If

End Sub
Sub Activity_KeyPress (KeyCode As Int) As Boolean 
   If KeyCode = KeyCodes.KEYCODE_BACK Then
			 If  Msgbox2 ("Saldrá del reporte del cultivo, ¿está seguro que desea continuar?" , "Advertencia","Pausar/Terminar","Cancelar","",Null) = DialogResponse.POSITIVE Then
				Activity.Finish 
			 End If
            Return True  'No continua con el evento propio de Android. Solo ejecuta nuestro código
    Else
		   Return False  'Continua con el comportamiento normal del botón
	End If
End Sub


Sub imgAyuda_Click
	Dim Intent1 As Intent
	Intent1.Initialize(Intent1.ACTION_VIEW, Base.g_ManualAyuda)
	
	Intent1.SetComponent("android/com.android.internal.app.ResolverActivity")
    Intent1.SetType("application/pdf")
    StartActivity(Intent1)
End Sub